


%breakdown_test.m


% problem is to minimize x'Rx + u'Qu s.t. x^* = A x + B u + C(w)
%  solving a min problem means setting sig < 0.  

R=1;
Q=1;
C=1;

A=1;
B=1;
beta=1;

% this solves a min problem

N=999;   % note 2000 is above the breakdown point
          % 1000 seems to be the breakdown point

Psave=zeros(N,1);
Fsave=zeros(N,1);
Ptsave=zeros(N,1);
Ksave=zeros(N,1);
Sigsave=zeros(N,1);

for i=1:N;
    
theta=1000/(130*(log(i+1)));
sig=-1/theta

[F,K,P,Pt]=olrprobust(beta,A,B,C,Q,R,sig);

Sigsave(i)=-sig;
Psave(i)=P;
Fsave(i)=F;
Ptsave(i)=Pt;
Ksave(i)=K;



end

close all
figure(1)
plot(Sigsave,Psave),title('P')
figure(2)
plot(Sigsave,Fsave),title('F')

figure(3)
plot(Sigsave,Ksave), title('K')

figure(4)
plot(Sigsave,Psave,'-b')
hold on
plot(Sigsave,Ksave,'--r')
hold on 
plot(Sigsave,Fsave,'-k')

disp('F K P at sig=0'),Fsave(1),Ksave(1), Psave(1)

disp('F K P at sig=1'),Fsave(N),Ksave(N), Psave(N)