% chapter2.m
%  revised version of Neng's program
% author: Neng Wang;

% with robustness sig<0, and beta*R=1;

diary 'chapter2.txt'
beta=.95;  % discount factor
raw_rate=1/beta; % beta*R=1; 
sig=-.000025;  %  risk sensitivity parameter
%sig=0;
theta=-1/sig; 

% convert a 2-factor AR2 process to 1-factor AR1;
twof_to_AR1; 

rho0=0; % a zero-mean income; 
% labor-income y' = rho0+rho*y+vol*epsilon; 

mub=18; 
% u(c)= -(c-mu_b)^2; define {\hat c}=c-mu_b as the control variable; 

A = [1 0 0 ; -mub raw_rate 1 ; rho0 0 rho];

B=[0 -1 0]';
C=[0 0 vol]';

nstate=size(A,1);
Q=zeros(nstate);
R=1;

%Ba=[B C];
%[rR,cR]=size(R);
%[rC,cC]=size(C);
%Ra=[R zeros(rR,cC);
%    zeros(cC,cR) -beta*theta];      %  there is only one shock

%Ad=beta^(.5)*A;%
%Bd=beta^(.5)*B;
%Cd=beta^(.5)*C;
%tic;
%[fd,pd]=olrp(beta,A,Ba,Q,Ra);
%toc

Ad=beta^(.5)*A;
Bd=beta^(.5)*B;
Cd=beta^(.5)*C; 

[Fd,Kd,Pd,Ptd]=doublex9(Ad,Bd,C,Q,R,sig)
Kd=Kd/sqrt(beta)   % we have to unwind the sqrt beta transform to get


% A+C*K; reduced form loading;
Ao=A + C*Kd; 



% consumption is therefore 
coef_wealth= -Fd(2)
coef_income= -Fd(3)
coef_const = mub-Fd(1)


coef=[coef_wealth; coef_income; coef_const];

%%%%%%===================================
%% check condition for marginal utility of consn
%% mu_{ct+1} = - F (A-BFd) y_t - Fd*C epsilon_{t+1}
%%           = - Fd y_t

%check1=Fd*(A-B*Fd)
%Fd
%check2=check1./Fd
%raw_rate*beta

%%%%%% ================================================
% alpha2 (shadow price squared for the mu);

alpha2=(Fd*C)*(Fd*C);


tmp0= (1+sig*alpha2)/(1+beta)^2;

tmp1=1+sqrt(1-4*beta*tmp0);

beta_hat = beta*(1+beta)*tmp1/(2*(1+sig*alpha2))


coef_wealth_obs=raw_rate-1/(beta_hat*raw_rate) 
coef_income_obs=coef_wealth_obs/(raw_rate-rho)


tmp4=rho0*coef_wealth_obs/(raw_rate-rho) - (1- 1/ ...
					    (beta_hat*raw_rate))*mub; 

coef_const_obs=tmp4/(raw_rate-1)


coef_obs=[coef_wealth_obs; coef_income_obs; coef_const_obs]


diff_coef=coef - coef_obs


%%%%==================================
%%% new stuff

%%% check with observationally equivalent value of sig,beta
%%  old values of beta and sig
beta
sig

beta=beta_hat
sig=0

Ad=beta^(.5)*A;
Bd=beta^(.5)*B;
Cd=beta^(.5)*C; 
[Fd2,Kd2,Pd2,Ptd2]=doublex9(Ad,Bd,C,Q,R,sig)
Kd2=Kd2/sqrt(beta)   % we have to unwind the sqrt beta transform to get

%%%%%%===================================
%% check condition for marginal utility of consn
%% mu_{ct+1} = - F (A-BFd) y_t - Fd*C epsilon_{t+1}
%%           = - (beta*raw_rate)^(-1)*Fd y_t

check1=Fd2*(A-B*Fd2)
check2=Fd2./(beta*raw_rate)
check3=check1./check2   % should be vector of 1's
raw_rate*beta

return
% A+C*K; reduced form loading;
Ao2=A + C*Kd2; 

% consumption is therefore 
coef_wealth2= -Fd2(2)
coef_income2= -Fd2(3)
coef_const2 = mub-Fd2(1)


coef2=[coef_wealth2; coef_income2; coef_const2];


coef-coef2


Pd-Pd2

Ptd-Ptd2


%   [KF3,K3,P3,Pt3]=cheap9(beta,A,B,C,Q,R,sig)
%   check this out later: this doesn't seem to work because of eigenvalue check
%   in olrp.m


diary off
