% chapter2a.m
%  version of Neng's program for computing numbers in chapter 2 example
%  for pih model

% with robustness sig<0, and beta*R=1;

diary 'chapter2.txt'
%beta=.95;  % discount factor
beta=.9971;  % hst's setting of discount facto
% beta=.98
raw_rate=1/beta; % beta*R=1; 
sig=-.000025;  %  risk sensitivity parameter
sig=-.0000002
theta=-1/sig; 

% convert a 2-factor AR2 process to 1-factor AR1;
twof_to_AR1; 

rho0=0; % a zero-mean income; 
% labor-income y' = rho0+rho*y+vol*epsilon; 

mub=18; 
% u(c)= -(c-mu_b)^2; define {\hat c}=c-mu_b as the control variable; 

A = [1 0 0 ; -mub raw_rate 1 ; rho0 0 rho];

B=[0 -1 0]';
C=[0 0 vol]';

nstate=size(A,1);
Q=zeros(nstate);
R=1;

%Ba=[B C];
%[rR,cR]=size(R);
%[rC,cC]=size(C);
%Ra=[R zeros(rR,cC);
%    zeros(cC,cR) -beta*theta];      %  there is only one shock

%Ad=beta^(.5)*A;%
%Bd=beta^(.5)*B;
%Cd=beta^(.5)*C;
%tic;
%[fd,pd]=olrp(beta,A,Ba,Q,Ra);
%toc

Ad=beta^(.5)*A;
Bd=beta^(.5)*B;
Cd=beta^(.5)*C; 

%%%%% first do pure Hall model to get section 1 rule

[Fh,Kh,Ph,Pth]=doublex9(Ad,Bd,C,Q,R,0)
Kh=Kh/sqrt(beta)   % we have to unwind the sqrt beta 

nu0=Fh*C    %  computes nu for pure hall model
Kh


[Fd,Kd,Pd,Ptd]=doublex9(Ad,Bd,C,Q,R,sig)
Kd=Kd/sqrt(beta)   % we have to unwind the sqrt beta transform to get






% A+C*K; reduced form loading;
Ao=A + C*Kd; 



% consumption is therefore 
coef_wealth= -Fd(2)
coef_income= -Fd(3)
coef_const = mub-Fd(1)


coef=[coef_wealth; coef_income; coef_const];

%%%%%%===================================
%% check condition for marginal utility of consn
%% mu_{ct+1} = - F (A-BFd) y_t - Fd*C epsilon_{t+1}
%%           = - Fd y_t

%check1=Fd*(A-B*Fd)
%Fd
%check2=check1./Fd
%raw_rate*beta

%%%%%% ================================================
% alpha2 (shadow price squared for the mu);

alpha2=(Fd*C)*(Fd*C);


tmp0= (1+sig*alpha2)/(1+beta)^2;

tmp1=1+sqrt(1-4*beta*tmp0);

beta_hat = beta*(1+beta)*tmp1/(2*(1+sig*alpha2))


coef_wealth_obs=raw_rate-1/(beta_hat*raw_rate) 
coef_income_obs=coef_wealth_obs/(raw_rate-rho)


tmp4=rho0*coef_wealth_obs/(raw_rate-rho) - (1- 1/ ...
					    (beta_hat*raw_rate))*mub; 

coef_const_obs=tmp4/(raw_rate-1)


coef_obs=[coef_wealth_obs; coef_income_obs; coef_const_obs]


diff_coef=coef - coef_obs


%%%%==================================
%%% new stuff

%%% check with observationally equivalent value of sig,beta
%%  old values of beta and sig
% first old parameter values
disp('beta'),beta
disp('sig'), sig
disp('raw_rate'), raw_rate
disp('vol'), vol
disp('beta*R'), beta*R
disp('rho'),rho
disp('beta_hat'), beta_hat
disp('A+C*Kd'),A+C*Kd
disp('Kd'),Kd
disp('Fd'),Fd
disp('alpha2'),alpha2
disp('nu'),sqrt(alpha2)
disp('A-B*Fd'),A-B*Fd



%% check the simplified formulation
%% min sum hat beta^t mu_{ct}^2 + hat beta *theta*w_t^2
%% s.t. mu_{ct} = (tilde beta*R)^{-1} mu_{ct-1} + nu w_t 
Am=(beta_hat*raw_rate)^(-1);nu=sqrt(alpha2);
Bm=nu;
Qm=1;Rm=beta/sig;
[f,p] = olrp(beta,Am,Bm,Qm,Rm)
%% now check
%% the worst case shock is w_{t+1} = -f * mu_ct = f Fd y_t
%% but also w_{t+1} = Kd y_t
%% so we should have f*Fd=Kd
% check0
disp('check0')
check0=(beta_hat*raw_rate)^(-1)+f*nu
beta
raw_rate

beta*raw_rate
disp('f*Fd'),f*Fd
disp('Kd'),Kd
disp('check5 should be vector of 1s')
f*Fd./Kd

disp('check4 should be 1')
check4=(beta_hat*raw_rate)^(-1) - f*nu
return

%%% 

%%%=======================
%% set up Stackelberg version 
%%

disp('A-B*Fd+C*Kd')
A-B*Fd+C*Kd

A
C*Kd
AA=[A C*Kd; zeros(3) A-B*Fd+ C*Kd];

BB=[B;zeros(size(B))];
CC=[C;zeros(size(C))];

QQ=zeros(6);
QQ=eye(6)*.0000001

[FF,PP] = olrp(beta,AA,BB,QQ,R)

AAd=beta^(.5)*AA;
BBd=beta^(.5)*BB;
CCd=beta^(.5)*CC; 

[FF,KK,PP,PtP]=doublex9(AAd,BBd,CCd,QQ,R,0)

FFtest=FF(1:3)+FF(4:6)
Fd-FFtest
return
beta=beta_hat
sig=0

Ad=beta^(.5)*A;
Bd=beta^(.5)*B;
Cd=beta^(.5)*C; 
[Fd2,Kd2,Pd2,Ptd2]=doublex9(Ad,Bd,C,Q,R,sig)
Kd2=Kd2/sqrt(beta)   % we have to unwind the sqrt beta transform to get

%%%%%%===================================
%% check condition for marginal utility of consn
%% mu_{ct+1} = - F (A-BFd) y_t - Fd*C epsilon_{t+1}
%%           = - (beta*raw_rate)^(-1)*Fd y_t

check1=Fd2*(A-B*Fd2)
check2=Fd2./(beta*raw_rate)
check3=check1./check2   % should be vector of 1's
raw_rate*beta

return
% A+C*K; reduced form loading;
Ao2=A + C*Kd2; 

% consumption is therefore 
coef_wealth2= -Fd2(2)
coef_income2= -Fd2(3)
coef_const2 = mub-Fd2(1)


coef2=[coef_wealth2; coef_income2; coef_const2];


coef-coef2


Pd-Pd2

Ptd-Ptd2


%   [KF3,K3,P3,Pt3]=cheap9(beta,A,B,C,Q,R,sig)
%   check this out later: this doesn't seem to work because of eigenvalue check
%   in olrp.m


diary off
