%  london03
%  test for stabilizing subspace of consumption problem
%%
%  set parameters of permanent income model (no habits)
%
%  Compute stabilizing subspace of the system with the mu_c stacked in with
% the other laws of motion.  Use this as way to solve the consumption problem.
%  Use this as link to time consistency issue.  
mub=30;
beta=.95;
R=beta^(-1);
mud=1;
rhod=.8;
k_0=5;

A=[1 0 0 0;
   -mub R 1 1;
   (1-rhod)*mud 0 rhod 0;
   0 0 0 (beta*R)^(-1) ];

RR=zeros(4);RR(4,4)=1;
RR(2,2)=.000005;

Astar =beta^(.5)*A;

PP=doublej(Astar',RR)

[V,D]=eig(Astar)


%  write system as 
% x_{t+1} = Astar x_t
%
% or 
%  inv(V) x_{t+1} = D inv(V) x_t
% 
% because the first element of D is explosive, we set
%
%  V^{-1}_1 x_0 = 0
% where V^{-1}_1 is the row of V_{-1} corresponding to the first eigenvalue),
% which in this case is unstable

iV=inv(V)

iV(1,:)

disp('coefficients on [1 k_{t-1} d_t mu_{ct}]'),iV(1,:)

disp('decision rule'),(iV(1,:)./iV(1,4))



%   Derive directly


% use Neng's trick: use c_t-b_t as control

a=[1 0 0;
   -mub R 1;
   (1-rhod)*mud 0 rhod];

b=[0 -1 0]';

rr=zeros(3,3); qq=-1;  
rr=.00000001*eye(3);


[F,P]=olrp(beta,a,b,rr,qq)

disp('Wow: the decision rule for mu_ct matches!!')

 

return


%II=eye(4);
%
%[VV,Lbar,Nbar,alpha,beta,info]=schurg(II,Astar,0,0,1e-15)

%[U,T]=schur(Astar)

%Astar-U*T*U'

%T-U'*Astar*U