%  lplq.m   BAD OLD VERSION: LPLQFINAL IS THE CORRECT ONE
% 
%  robust version of Lucas-Prescott investment under uncertainty model
%  Compute equilibrium in two ways and check consistency

     a0= 100;    % intercept of demand function
     a1=1;      % slope of demand function
     rho=0.9;   % autocorrelation factor  % originally set at .8
     Ce=.2;     % variance of shocks
     c=10;      % adjustment cost factor  % originally set at 1
     b=0.95;    % discount factor
     %b=.9999;
     d=20;      % unit cost for competitive firm
     e=20;      % unit cost for large firm
     g=1;     %  quadratic term in cost function for large firm; originally set at .2
     h=1;      % quadratic term in cost function for competitive firm% originally set at .2
     
     thf=1000000000000000000;
 
 %  August 3: 1:00 p.m.  It checks with thf=big, but not thf=small
 % step 1: solve the robust planning problem
 %
 % state is [1 q_t v_t]
 % 
 %  
 A=[1 0 0;
     0 1 0;
     0 0 rho];
 B=[0 1 0]';
 C=[0 0 Ce]';
 
 Q=[ 0 .5*(a0-d) 0;
     .5*(a0-d) -.5*(a1+h) .5;
     0    .5 0 ];
 R=-.5*c;
 
 As=A*sqrt(b)
  Bs=B*sqrt(b)
 [Fs,Ks,Ps,Pst]=doublex9(As,Bs,C,Q,R,-1/thf);
 Ks=b^(-.5)*Ks;
 Fs
 Ks

 %  step 2: solve the representative firm's problem:

 % state is now [1 qbar q v]
 %
 % first construct the law of motion of qbar_{t+1}= df*state
 df=zeros(1,4);
 
 df(1)=-Fs(1);
 df(2)=1-Fs(2);
 df(4)=-Fs(3);
 
 Af=[1 0 0 0;
     df;   % pick off the 1, qbar, v components of F -- remember - sign
     0 0 1 0 ;
     0 0 0 rho];
 Bf=[0 0 1 0]';
 Cf=[0 0 0 Ce]';

 Qf=[0 0 .5*(a0-d) 0 ;
     0 0 -a1/2 0;
    .5*(a0-d) -a1/2 -.5*h .5;
    0 0 .5 0];

  Rf=-.5*c;
  
  Afs=Af*sqrt(b)
  Bfs=Bf*sqrt(b)
  

 [Ffs,Kfs,Pfs,Pfst]=doublex9(Afs,Bfs,Cf,Qf,Rf,-1/thf);
 
 Kfs=b^(-.5)*Kfs;
 Ffs
 Kfs

% now do the check

Fcheck=zeros(1,3);
Fcheck(1)=Ffs(1);
Fcheck(2)=Ffs(2)+Ffs(3);
Fcheck(3)=Ffs(4);

Fcheck-Fs

Kcheck=zeros(1,3);
Kcheck(1)=Kfs(1);
Kcheck(2)=Kfs(2)+Kfs(3);
Kcheck(3)=Kfs(4);

Kcheck-Ks

return


%% step 4 `fourth way'  -- try `worst case' law of motion for the v process
%% and let the representative firm perturb it:


df=zeros(1,4);
 
 df(1)=-Fs(1);
 df(2)=1-Fs(2);
 df(4)=-Fs(3);
 
 
dvbar=zeros(1,4);
dvbar(1)=Ks(1);    % constant
dvbar(2)=Ks(2);    % coeff on qbar
dvbar(4)=Ks(3);    % coeff on vbar
 
 Aff=[1 0 0 0;
     df;   % pick off the 1, qbar, v components of F -- remember - sign
     0 0 1 0 ;
     dvbar];
 Bff=[0 0 1 0]';
 Cf=[0 0 0 Ce]';

 Qf=[0 0 .5*(a0-d) 0 ;
     0 0 -a1/2 0;
    .5*(a0-d) -a1/2 -.5*h .5;
    0 0 .5 0];

  Rf=-.5*c;
  
  
  Affs=Aff*sqrt(b)
  Bffs=Bff*sqrt(b)
  

 [Fffs,Kffs,Pffs,Pffst]=doublex9(Affs,Bffs,Cf,Qf,Rf,-1/thf);
 Kffs=b^(-.5)*Kffs;
 Fffs
 Kffs

%Now do the check
 
Fcheck3=zeros(1,3);
Fcheck3(1)=Fffs(1);
Fcheck3(2)=Fffs(2)+Fffs(3);
Fcheck3(3)=Fffs(4);

Fcheck3-Fs

Kcheck3=zeros(1,3);
Kcheck3(1)=Kffs(1);
Kcheck3(2)=Kffs(2)+Kffs(3);
Kcheck3(3)=Kfs(4);

Kcheck3-Ks
 
return


%% step 3: `third try' -- here the state is [1 qbar vbar q v];

dqbar=zeros(1,5);
dqbar(1)=-Fs(1);   % constant
dqbar(2)=1-Fs(2);  % coeff on qbar
% dqbar(5) = -Fs(3); % coeff on vbar
dqbar(3) = -Fs(3); % coeff on vbar

dvbar=zeros(1,5);
dvbar(1)=Ks(1);    % constant
dvbar(2)=Ks(2);    % coeff on qbar
dvbar(3)=Ks(3);    % coeff on vbar

Aa=[1 0 0 0 0;
    dqbar;
    dvbar;
    0 0 0 1 0;
    0 0 0 0 rho];

Ba=[0 0 0 1 0]';

Ca=[0 0  0 0 Ce]';

Qa=[0 0  0 .5*(a0-d) 0 ;
     0 0 0 -a1/2 0;
    0 0 0 0 0 ;
    .5*(a0-d) -a1/2 0 -.5*h .5;
    0 0 0 .5 0];
 Ra=-.5*c; 
 
  Afsa=Aa*sqrt(b);
  Bfsa=Ba*sqrt(b);
  
  


 [Ffa,Kfa,Pfa,Pfat]=doublex9(Afsa,Bfsa,Ca,Qa,Ra,-1/thf);
 Kfa=b^(-.5)*Kfa;
  
 Fcheck2=zeros(1,3);
 
 Fcheck2(1)=Ffa(1);
 Fcheck2(2)=Ffa(2)+Ffa(4);
 Fcheck2(3)=Ffa(3)+Ffa(5);
 
 Fcheck
 Fcheck2
 Fs
 