%  lplq3.m  BAD OLD VERSION: LPLPFINAL IS THE CORRECT ONE
%  Correct version -- steps 1 and step 3 are consistent. Delete step 2,
%  which implemented Lars's Aug 3 suggestion but that doesn't work.
% 
%  robust version of Lucas-Prescott investment under uncertainty model
%  Compute equilibrium in two ways and check consistency

     a0= 100;    % intercept of demand function
     a1=1;      % slope of demand function
     rho=0.9;   % autocorrelation factor  % originally set at .8
     Ce=.2;     % variance of shocks
     c=10;      % adjustment cost factor  % originally set at 1
     b=0.95;    % discount factor
%      b=.9999;
     d=20;      % unit cost for competitive firm
     e=20;      % unit cost for large firm
     g=1;     %  quadratic term in cost function for large firm; originally set at .2
     h=1;      % quadratic term in cost function for competitive firm% originally set at .2
     
     thf=30;
 
 %  August 3: 10:15 p.m.  Step 3 is the setup that works -- you have to use
 %  the larger state space with distorted X in state space.  
 %
 % Ignore step 2 and go to step 3, which nails it!!!
 
 % step 1: solve the robust planning problem
 %
 % state is [1 q_t v_t]
 % 
 %  
 A=[1 0 0;
     0 1 0;
     0 0 rho];
 B=[0 1 0]';
 C=[0 0 Ce]';
 
 Q=[ 0 .5*(a0-d) 0;
     .5*(a0-d) -.5*(a1+h) .5;
     0    .5 0 ];
%  Q=Q-.000001*eye(3);   % trick to pump up rank
 R=-.5*c;
 
 As=A*sqrt(b)
  Bs=B*sqrt(b)
 [Fs,Ks,Ps,Pst]=doublex9(As,Bs,C,Q,R,-1/thf);
 Ks=b^(-.5)*Ks;
 Fs
 Ks
 
 
 % Solve the optimal linear regulator from the above matrices
RMM=[-c/2 0; 0 -b*thf];
% BM= [zeros(8,1);1];
% CM=[CM1;Ce;0];
BMM=[B C];
esmall=.00001;
QMM=Q+eye(3)*esmall;
tic;     
[Fo Po]= olrp(b,A,BMM,QMM,RMM);
toc;


%  
% Now compute the worst case law of motion of \bar q

Aoo=A-B*Fs+C*Ks;   %  this computes the worst case law of motion for [1 q v];

%%% skip step 2 and go to step 3.
 %  step 2: solve the representative firm's problem:

 % state is now [1 qbar q v]
 %
 % first construct the law of motion of qbar_{t+1}= df*state
 %  
 % first we'll do it the "original way" we tried that ignores the CK term
 dfo=zeros(1,4);
 
 dfo(1)=-Fs(1);
 dfo(2)=1-Fs(2);

 dfo(4)=-Fs(3);

df=zeros(1,4);
df(1)=Aoo(2,1);
df(2)=Aoo(2,2);
df(4)=Aoo(2,3);
 
 Af=[1 0 0 0;
     df;   % pick off the 1, qbar, v components of F -- remember - sign
     0 0 1 0 ;
     0 0 0 rho];
 Bf=[0 0 1 0]';
 Cf=[0 0 0 Ce]';

 Qf=[0 0 .5*(a0-d) 0 ;
     0 0 -a1/2 0;
    .5*(a0-d) -a1/2 -.5*h .5;
    0 0 .5 0];
%  Qf = Qf - .0000001*eye(4)
  Rf=-.5*c;
  
  Afs=Af*sqrt(b)
  Bfs=Bf*sqrt(b)
  

 [Ffs,Kfs,Pfs,Pfst]=doublex9(Afs,Bfs,Cf,Qf,Rf,-1/thf);
 
 Kfs=b^(-.5)*Kfs;
 Ffs
 Kfs

 %%%
 % Solve the optimal linear regulator from the above matrices
RMM=[-c/2 0; 0 -b*thf];
% BM= [zeros(8,1);1];
% CM=[CM1;Ce;0];
BM=[Bf Cf];
esmall=.00001;
QM=Qf+eye(4)*esmall;
tic;     
[Foo Poo]= olrp(b,Af,BM,QM,RMM);
toc;
 
 %%%%
 
 
% now do the check

Fcheck=zeros(1,3);
Fcheck(1)=Ffs(1);
Fcheck(2)=Ffs(2)+Ffs(3);
Fcheck(3)=Ffs(4);

Fcheck-Fs

Kcheck=zeros(1,3);
Kcheck(1)=Kfs(1);
Kcheck(2)=Kfs(2)+Kfs(3);
Kcheck(3)=Kfs(4);
disp('Ks="'),Ks
disp('Kcheck='),Kcheck
disp('Ks-Kcheck="'),Ks-Kcheck

disp('Fs="'),Fs
disp('Fcheck='),Fcheck
disp('Fs-Fcheck="'),Fs-Fcheck







%% step 3: `third try' -- here the state is [1 qbar vbar q v] (see the
%% monograph). This works.  

% Form law of motion for qbar, vbar in the big X.
% first qbar
dqbar=zeros(1,5);
dqbar(1)=-Fs(1);   % constant
dqbar(2)=1-Fs(2);  % coeff on qbar
% dqbar(5) = -Fs(3); % coeff on vbar
dqbar(3) = -Fs(3); % coeff on vbar

% Form law of motion for vbar.  
% dvbar=zeros(1,5);
% dvbar(1)=Ks(1);    % constant
% dvbar(2)=Ks(2);    % coeff on qbar
% dvbar(3)=Ks(3);    % coeff on vbar

% Form law of motion for vbar.  -- This is the correct one.  
dvbar=zeros(1,5);
dvbar(1)=Aoo(3,1);
dvbar(2)=Aoo(3,2);
dvbar(3)=Aoo(3,3);

Aa=[1 0 0 0 0;
    dqbar;
    dvbar;
    0 0 0 1 0;
    0 0 0 0 rho];

Ba=[0 0 0 1 0]';

Ca=[0 0  0 0 Ce]';

Qa=[0 0  0 .5*(a0-d) 0 ;
     0 0 0 -a1/2 0;
    0 0 0 0 0 ;
    .5*(a0-d) -a1/2 0 -.5*h .5;
    0 0 0 .5 0];
 Ra=-.5*c; 
 
  Afsa=Aa*sqrt(b);
  Bfsa=Ba*sqrt(b);
  
  


 [Ffa,Kfa,Pfa,Pfat]=doublex9(Afsa,Bfsa,Ca,Qa,Ra,-1/thf);
 Kfa=b^(-.5)*Kfa;
  
 Fcheck2=zeros(1,3);
 
 Fcheck2(1)=Ffa(1);
 Fcheck2(2)=Ffa(2)+Ffa(4);
 Fcheck2(3)=Ffa(3)+Ffa(5);
 
 
 Kcheck2=zeros(1,3);
 
 Kcheck2(1)=Kfa(1);
 Kcheck2(2)=Kfa(2)+Kfa(4);
 Kcheck2(3)=Kfa(3)+Kfa(5);
 

 Fcheck2
 Fs
 
 Kcheck2
 Ks
 
return

%% step 4 `fourth way'  -- try `worst case' law of motion for the v process
%% and let the representative firm perturb it:


df=zeros(1,4);
 
 df(1)=-Fs(1);
 df(2)=1-Fs(2);
 df(4)=-Fs(3);
 
 
dvbar=zeros(1,4);
dvbar(1)=Ks(1);    % constant
dvbar(2)=Ks(2);    % coeff on qbar
dvbar(4)=Ks(3);    % coeff on vbar
 
 Aff=[1 0 0 0;
     df;   % pick off the 1, qbar, v components of F -- remember - sign
     0 0 1 0 ;
     dvbar];
 Bff=[0 0 1 0]';
 Cf=[0 0 0 Ce]';

 Qf=[0 0 .5*(a0-d) 0 ;
     0 0 -a1/2 0;
    .5*(a0-d) -a1/2 -.5*h .5;
    0 0 .5 0];

  Rf=-.5*c;
  
  
  Affs=Aff*sqrt(b)
  Bffs=Bff*sqrt(b)
  

 [Fffs,Kffs,Pffs,Pffst]=doublex9(Affs,Bffs,Cf,Qf,Rf,-1/thf);
 Kffs=b^(-.5)*Kffs;
 Fffs
 Kffs

%Now do the check
 
Fcheck3=zeros(1,3);
Fcheck3(1)=Fffs(1);
Fcheck3(2)=Fffs(2)+Fffs(3);
Fcheck3(3)=Fffs(4);

Fcheck3-Fs

Kcheck3=zeros(1,3);
Kcheck3(1)=Kffs(1);
Kcheck3(2)=Kffs(2)+Kffs(3);
Kcheck3(3)=Kfs(4);

Kcheck3-Ks
 
return

