%
%  managegv7.m
%  modified version of managegv6.m, to plot graphs only with respect
%  to the first shock and fine tune them for the paper.
% revised from managegv3.m, incorporating the right order after
% changeing the number of shocks, beautifying the graphs

%  tom edited Chao's version, Feb 26, 1999
%  
%  runs task24gv4 for two values of theta and plots the results
%
% set parameter values

clear

beta  = .99;       % discount rate
sig = 0.157;       % IS curve parameter
kappa = 0.024;     % Phillips curve parameter
lamx  = 0.047;     % weight on x in objective
lamr  = 0.233;     % weight on r in objective

%lamx=.47;   %   experimental parameters

% set parameters for the transition motion of X

rho = .35;   %  Woodford's number

rho=.8;

  rho=.8;   %  temporary value -- .8 generates nice graphs
  
  
  theta1 = 1e+15;
 theta2 =1e+4/6;   theta2=1e+3;  theta2=2e+3;
 theta2=23;
 
 rho=.35; theta2=2;
 rho=.8; theta2=22.75;   
 
 
 mrn = 0.4;   % (mean of r_{t}^{n})*(1-rho)
ssrn = 3.72;   % std of r_{t}^{n} 
sigg1 = 1.5;     % std of epsilon_1 (error for phillips curve) 
 sigg1=.00   ; sigg2=.00;  % shut down the IS and Phillips curve shocks
%sigg2 = .05;     % std of epsilon_2 (error for IS curve) 
rho1 = 0.8;    % persistence parameter for epsilon_1
rho2 = 0.9;    % persistence parameter for epsilon_2

%  do transform to get st of innovation to rn

srn=(sqrt(1-rho^2))*ssrn;     %  srn is std of innovation to rn
sig1=(sqrt(1-rho1^2))*sigg1;  %  std of innov to error for Phillips
sig2=(sqrt(1-rho2^2))*sigg2;  %  std of innov to error for IS curve
% invoke formulas on page 10 of woodrob3.ps

 A = [1 0 0 0;
    mrn/(1-rho) rho 0 0;
    0 0 rho1 0;
    0 0 0 rho2];
 C = [0 0 0;  srn 0 0; 0 sig1 0; 0 0 sig2];  
 								  %  change from what Chao had.  Note: there
 								  % are now three separate shocks
 
 na = size(A,1);
 
 nc = size(C,2);     % number of shocks
 
 EE = eye(na);
 
 % calculate for two different values of theta
 
  [AA1,CC1,GG1,DD1] = task24gv4(A,C,EE,theta1);
 [AA2,CC2,GG2,DD2] = task24gv4(A,C,EE,theta2);
 
   sys1=ss(AA1,CC1,GG1,DD1,1);
   sys2=ss(AA2,CC2,GG2,DD2,1);
   
   T = 50;
   
   
   %impulse(sys1,T),title('resp of \chi, r, w_{t+1}, r^n')
   
   [y1,t1,z1]=impulse(sys1,T);
   [y2,t2,z2]=impulse(sys2,T);
  
% y is the tensor corresponding to sys1 system. 
% If SYS has NU inputs and NY outputs, and LT=length(T), 
% where T is the simulation period, the array y is   
% LT-by-NY-by-NU  and y(:,:,j) gives 
% the impulse response of the j-th input channel.

   [rt1,ct1,pt1] = size(y1); %dimension for theta1 case
   [rt2,ct2,pt2] = size(y2); %dimension for theta2 case
   
   [rz1,cz1,pz1] = size(z1); %dimension
   [rz2,cz2,pz2] = size(z2); %dimension

% Given the particular structure of y, i.e. 101 by 11 by 3, we can easily 
% change multiple dimension array into matrix. tempts1 is a 101*11 by 3 matrix 
% obtained by stacking matrix y(:,:,j) into 101 by 1 column vector and 
% then make the "vectorized" y(:,:,j) become the jth column in tempts1. 

tempts1  = reshape(y1,rt1*ct1,pt1);
tempts2  = reshape(y2,rt2*ct2,pt2);

temptz1  = reshape(z1,rz1*cz1,pz1);
temptz2  = reshape(z2,rz2*cz2,pz2);

% Then we operate on tempts1 by moving "blocks" around and finally make 
% it into two new matries: capts1 and capts2, both of the dimension
% 101 by 12. 

% The first three columns of capts1 contains the impulse 
% responses to \pi from w_{1,2,3} sequentially, the second three columns
% contains the IMR to x from the three shocks(4:6th), the third three columns 
% IMR to r(7:9), the fourth three columns IMR to r_t^n(10:12).

% The first three columns of capts2 contains the impulse 
% responses to \mu_{1} from w_{1,2,3} sequentially, the second three columns
% contains the IMR to \mu_{2} from the three shocks(4:6th), the third three columns 
% IMR to mu_{3},(7:9), the fourth three columns IMR to mu_{4},(10:12th).

% For capts*, the jth column corresponds to 
% the jth sub-figure in subplot graph. This manipulation just intends 
% to make the subsequent plot loops easier.

capts1 = zeros(rt1,ct1*pt1);
capts2 = zeros(rt2,ct2*pt2);

captz1 = zeros(rz1,cz1*pz1);
captz2 = zeros(rz2,cz2*pz2);

for i = 1:ct1
   
   capts1(1:rt1,1+pt1*(i-1):pt1*i)=tempts1(1+rt1*(i-1):rt1*i,:);
   capts2(1:rt2,1+pt2*(i-1):pt2*i)=tempts2(1+rt2*(i-1):rt2*i,:);
     
end

for i = 1:cz1
   
   captz1(1:rz1,1+pz1*(i-1):pz1*i)=temptz1(1+rz1*(i-1):rz1*i,:);
   captz2(1:rz2,1+pz2*(i-1):pz2*i)=temptz2(1+rz2*(i-1):rz2*i,:);
     
end

capts11 = [capts1(:,1:6),capts1(:,19:21),capts1(:,31:33)];% pi,x,r,rtn
capts21 = [capts2(:,1:6),capts2(:,19:21),capts2(:,31:33)];% pi,x,r,rtn

capts12 = [capts1(:,22:30)];       % \w_{1,2,3,4}
capts22 = [capts2(:,22:30)];       % \w_{1,2,3,4}

captz11 = captz1(:,1:6);  % \phi1 and phi2
captz21 = captz2(:,1:6);

figure(1)

TT=22;
plot(t1(1:TT-1), capts11(2:TT,7),'r-')
hold on
plot(t2(1:TT-1),capts21(2:TT,7),'b--')
hold off 
title(['From \eta_{t}'])
ylabel('To r_{t}')

print -deps king1

figure(2)

plot(t1(1:TT-1), capts12(2:TT,1),'r-')
hold on
plot(t2(1:TT-1),capts22(2:TT,1),'b--')
hold off 
title(['From eta_{t}'])
ylabel('To w_{t}')

print -deps king2
figure(3)
subplot(2,1,1)
plot(t1(1:TT-1),captz11(2:TT,1),'r-')
hold on
plot(t2(1:TT-1),captz21(2:TT,1),'b--')
hold off
title(['From \eta_{t}'])
ylabel(['To \mu_{s1}'])
subplot(2,1,2)
plot(t1(1:TT-1),captz11(2:TT,4),'r-')
hold on
plot(t2(1:TT-1),captz21(2:TT,4),'b--')
hold off

ylabel(['To \mu_{s2}'])

print -deps king3

return
figure(2)

for i = 1:12
      
   subplot(4,3,i)
      
plot(t1,capts11(:,i),'r-')
hold on
plot(t2,capts21(:,i),'b--')
hold off

if i == 1
   title(['From v_{1}'])
elseif i == 2
   title(['From v_{2}'])
   elseif i == 3
      title(['From v_{3}'])
end

if i == 1
ylabel('To \pi_{t}')
elseif i == 4
   ylabel('To x_{t}')
elseif i == 7
   ylabel('To r_{t}')
elseif i == 10
   ylabel('To r_{n}^{t}')
elseif rem(i,3) == 0
   set(gca,'YAxisLocation','right')
end

axis([0 T -inf inf])
%grid on
end

print -deps woodf1.eps

figure(4)

for i = 1:9
      
   subplot(3,3,i)
      
   plot(t1,capts12(:,i),'r-')
   hold on
   plot(t2,capts22(:,i),'b--')
   hold off


if i == 1
   title(['From v_{1}'])
elseif i == 2
   title(['From v_{2}'])
   elseif i == 3
      title(['From v_{3}'])
end


if i == 1
ylabel('To w_{1}')
elseif i == 4
   ylabel('To w_{2}')
elseif i == 7
   ylabel('To w_{3}')
elseif rem(i,3) == 0
   set(gca,'YAxisLocation','right')
end

axis([0 T -inf inf])
%grid on
end

print -deps woodf2.eps

figure(3)

for i = 1:6
      
   subplot(2,3,i)
      
plot(t1,captz11(:,i),'r-')
hold on
plot(t2,captz21(:,i),'b--')
hold off

if i == 1
   title(['From v_{1}'])
elseif i == 2
   title(['From v_{2}'])
   elseif i == 3
      title(['From v_{3}'])
end


if i == 1
ylabel('To \phi_{1}')
elseif i == 4
   ylabel('To \phi_{2}')
elseif i == 7
   ylabel('To \phi_{3}')
elseif rem(i,3) == 0
   set(gca,'YAxisLocation','right')
end

axis([0 T -inf inf])
%grid on
end

%  chi is pi_t, x_t, mu_t
   %  Z is \phi_1, \phi_2, X_t
   
   
print -deps woodf3.eps   
return

figure(1)


theta=1e+3;
disp('theta=100')

[AA,CC,GG,DD] = task24gv3(A,C,EE,theta);

   sys1=ss(AA,CC,GG,DD,1);
   T = 150;
   impulse(sys1,T),title('resp of \chi, r, w_{t+1}, r^n')
   [y,t,z]=impulse(sys1,T);

figure(5)


subplot(3,1,1),plot(y(:,3+na)),ylabel('r_t')
subplot(3,1,2),plot(y(:,5+na)),ylabel('r_t^n')
subplot(3,1,3),plot(y(:,4+na)),ylabel('w_{t+1}')

figure(6)

subplot(3,1,1),plot(y(:,1)),ylabel('\pi_t')
subplot(3,1,2),plot(y(:,2)),ylabel('x_t')
subplot(3,1,3),plot(z(:,2+na)),ylabel('y^n-g') 

y2=y;
z2=z;

figure(7)

plot([y1(:,4+na), y2(:,4+na)]), ylabel('w_t')
figure(8)

plot([y1(:,3+na), y2(:,3+na)]), ylabel('r_t')
figure(9)

plot([y1(:,5+na), y2(:,5+na)]), ylabel('r^n_t')
