
% print out the plot of observational equivalence for
% both hst and hsw on the same graph;
% the theory predicts that the slope for hsw case is
% steeper because of extra robustness concern;

load mprhswmat
load mprhstmat
load mprbenchmat
load sigsmat 

sigs_extend=[sigs 0];
beta_eqhsw_extend=[beta_eqhsw(1,:) beta];

beta_eqhst_extend=[beta_eqhst(1,:) beta];

beta_bench_extend=[beta_bench(1,:) beta];

plot(sigs_extend,beta_eqhsw_extend,'yx-',sigs_extend, ...
     beta_eqhst_extend,'r+:',sigs_extend,beta_bench_extend,'gd--') 
title(['Observationally Equivalent Discount Factors/Robustness' ...
       ' Parameters'])
xlabel('Robustness parameter')
%ylabel('Observationally equivalent discount factor')
legend('Main model','HST model','Benchmark model',2)


axis([-8e-5 0 0.994 beta])
print -deps obseq;
