function[xs]=sstate(a,nc)
%function[xs]=sstate(a,nc)
% computes steady state of state space system.
%  a is a transition matrix for a state space system
%
%  x(1+1) = a x(t)
%
%  nc is the position of the constant (1) in the vector x, e.g., nc=2 if
%  the constant is the second element of x.  
%  sstate(a,n) is the steady state of the system

nsize=max(size(a));
e1=eye(nsize);
xx=null(e1-a);
xs=xx./xx(nc);