% test2.m
%  program to test equivalence of doublex9 and olrp as ways of computing
% robust rule.  End of program computes "pure prediction" example

%  Test problem
%  one shock two states two controls

A=.9*eye(2)
B=[1 .5; 0 1];
C=[.5;.5];
Q=eye(2);
R=eye(2);


beta=.95;  % discount factor

sig=-.01;  %  risk sensitivity parameter
theta=-1/sig; 

%  first use olrp by augmenting the control matrix and adjustment cost matrix

Ba=[B C];
[rR,cR]=size(R);
[rC,cC]=size(C);
Ra=[R zeros(rR,cC);
    zeros(cC,cR) -beta*theta];      %  there is only one shock
  
%  first compare olrp and doublex9 for the undiscounted problem

[f,p] = olrp(beta,A,Ba,Q,Ra)

[F,K,P,Pt]=doublex9(A,B,C,Q,R,sig)

%  now adjust A, B for discounting in the doublex9 problem
%

beta=.95;

%  simply multiply A, B, C by sqrt(beta)

Ad=beta^(.5)*A;
Bd=beta^(.5)*B;
Cd=beta^(.5)*C;
tic
[fd,pd]=olrp(beta,A,Ba,Q,Ra);
toc
tic
[Fd,Kd,Pd,Ptd]=doublex9(Ad,Bd,Cd,Q,R,sig);
toc
Pd
pd

Pd-pd

fd

[Fd;-Kd]

fd-[Fd;-Kd]





%  now test pure prediction problem
%%  
%% x'Qx - beta*theta* w'w
%%
%% y' = A x + C w

theta=1000000000000;

[fw,pw] = olrp(beta,A,C,Q,-beta*theta)

A-C*fw
eig(A-C*fw)
