%test4.m
% this program tests and verifies two ways to compute robust rules.
% one way is to use cheap9.m, which uses the simple stacked algorithm
% of chapter 2.  The other is to use doublex9.m, adjusting for discount
% factors appropriately. Notice that you have to "unwind" the discount
% factor to compute K properly.  The last part of this program
% computes K directly from first principles using the direct formula.


A=.9*eye(2)
%B=[1 .5; 0 1];
B=[1 .5]';

C=[.5;.5];
Q=eye(2);
%R=eye(2);
R=eye(1);


beta=.95;  % discount factor
%beta=1;
sig=-.01;  %  risk sensitivity parameter
theta=-1/sig; 



Ba=[B C];
[rR,cR]=size(R);
[rC,cC]=size(C);
Ra=[R zeros(rR,cC);
    zeros(cC,cR) -beta*theta];      %  there is only one shock


Ad=beta^(.5)*A;
Bd=beta^(.5)*B;
Cd=beta^(.5)*C;
tic;
[fd,pd]=olrp(beta,A,Ba,Q,Ra);
toc

Ad=beta^(.5)*A;
Bd=beta^(.5)*B;
%Cd=beta^(.5)*C;
tic
[Fd,Kd,Pd,Ptd]=doublex9(Ad,Bd,C,Q,R,sig);
Kd=Kd/sqrt(beta)   % we have to unwind the sqrt beta transform to get
%%  K component
toc

Pd
pd

Pd-pd

fd

[Fd;-Kd]

fd-[Fd;-Kd]


[fc,kc,pc,ptc]=cheap9(beta,A,B,C,Q,R,sig)

fd-[fc;-kc]  % this checks out -- it equals zero

fd-[Fd;-Kd]  % the k components disagree

Kd./kc

sqrt(beta)

Kd./kc-sqrt(beta)

%  therefore Kd = sqrt(beta) kc

ptc./Ptd  %  checks out as 1: therefore ptc = Ptd
% direct calculation


Ktest=inv(theta*eye(cC)-C'*pc*C)*C'*pc*(A-B*fc) 
Ktest-kc

