% test_AR_neng.m

% author: Neng Wang for RA work for Tom;  



% with robustness sig<0, and beta*R=1;

!\rm test_AR_neng2.txt'

diary 'test_AR_neng2.txt'

beta=.95;  % discount factor

raw_rate=1/beta; % beta*R=1; 

sig=-.000025;  %  risk sensitivity parameter

%sig=0;

theta=-1/sig; 



% convert a 2-factor AR2 process to 1-factor AR1;

twof_to_AR1; 



rho0=0; % a zero-mean income; 

% labor-income y' = rho0+rho*y+vol*epsilon; 



mub=18; 

% u(c)= -(c-mu_b)^2; define {\hat c}=c-mu_b as the control variable; 



A = [1 0 0 ; -mub raw_rate 1 ; rho0 0 rho];



B=[0 -1 0]';

C=[0 0 vol]';



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%% Solve the optimal consumption rule using doublex9;  

nstate=size(A,1);

Q=zeros(nstate);

R=1;



%Ba=[B C];

%[rR,cR]=size(R);

%[rC,cC]=size(C);

%Ra=[R zeros(rR,cC);

%    zeros(cC,cR) -beta*theta];      %  there is only one shock



%Ad=beta^(.5)*A;%

%Bd=beta^(.5)*B;

%Cd=beta^(.5)*C;

%tic;

%[fd,pd]=olrp(beta,A,Ba,Q,Ra);

%toc



Ad=beta^(.5)*A;

Bd=beta^(.5)*B;

Cd=beta^(.5)*C; 



[Fd,Kd,Pd,Ptd]=doublex9(Ad,Bd,C,Q,R,sig)

Kd=Kd/sqrt(beta)   % we have to unwind the sqrt beta transform to get





% A+C*K; reduced form loading;

Ao=A + C*Kd; 



% consumption c is  

% c = coef_wealth* x + coef_income *y + coef_const 



coef_wealth= -Fd(2)

coef_income= -Fd(3)

coef_const = mub-Fd(1)





coef=[coef_wealth; coef_income; coef_const];



%%%%%%%%%%%% end of dobulex9 method of solving the example

%%%%%%%%%%%%







%%%%%%% Start the second method--see my research note tom_ra.pdf



% alpha2 (shadow price squared for the mu);

alpha2=(Fd*C)*(Fd*C)';





%%% use the observational equivalence II to obtain

%beta_hat,from the original specification (sigma<0 and beta*raw_rate=1)

tmp0= (1+sig*alpha2)/(1+beta)^2;



tmp1=1+sqrt(1-4*beta*tmp0);



beta_hat = beta*(1+beta)*tmp1/(2*(1+sig*alpha2))





%%%%% use the formulas from tom_ra.pdf to calculate the

%coefficients directly; Note that these formulas use the 

% (\hat \sigma =0, \hat \beta = beta_hat, computed above)

% Therefore, a standard Euler equation with \hat \beta

% raw_rate >1 and quadratic utility 





% consumption rule c is 

% c = coef_wealth_obs* x + coef_income_obs * y + coef_const_obs; 



coef_wealth_obs=raw_rate-1/(beta_hat*raw_rate) 

coef_income_obs=coef_wealth_obs/(raw_rate-rho)



tmp4=rho0*coef_wealth_obs/(raw_rate-rho) - (1- 1/ ...

					    (beta_hat*raw_rate))*mub; 



coef_const_obs=tmp4/(raw_rate-1)



%%% Collect the coefficients using the observational

%equivalence II; 



coef_obs=[coef_wealth_obs; coef_income_obs; coef_const_obs]





% check the numerical difference; 



diff_coef=coef - coef_obs





%%%%%% end of calculation using observational equivalence II

%%%%%% and the explicit formula in tom_ra; 



%%%%%% start of The third approach 

%%%%%% still use the observational equivalence II

%%%%%% with the doublex9 at \hat \sigma = 0. 





Ad_hat=beta_hat^(.5)*A;

Bd_hat=beta_hat^(.5)*B;

Cd_hat=beta_hat^(.5)*C; 



[Fd_hat,Kd_hat,Pd_hat,Ptd_hat]=doublex9(Ad_hat,Bd_hat,C,Q,R,0)

Kd_hat=Kd_hat/sqrt(beta_hat)   

% we have to unwind the sqrt beta transform to get 



%% consumption rule c is 

%% c = coef_wealth_hat*x + coef_income_hat * y + coef_const_hat;



coef_wealth_hat= -Fd_hat(2)

coef_income_hat= -Fd_hat(3)

coef_const_hat = mub-Fd_hat(1)





coef_hat=[coef_wealth_hat; coef_income_hat; coef_const_hat];



diff_coef2=coef - coef_hat



diary off

