%twotooneb
%  amendment of Neng's program
% This program converts a 2-factor AR2 process to a
% univariate AR1 process; 


format compact
format long
format short
param;

% display some remarks 
%disp('output for .txt')
%disp(['this program uses infered state vector from hst'])
%disp('as the filtered state vector')
%disp('with new construct of the state variables')
%disp('')
disp('the parameter values')
phi1
phi2
alpha1
alpha2
c1
c2

% define some constants;
g1=phi1+phi2;
a1=alpha1+alpha2;
g2=-phi1*phi2;
a2=-alpha1*alpha2;

% the state process z_{t+1}=Az*z_t + Cz*w_{t+1}; 
% z_{t+1}=[d1_{t+1} d1_t d2_{t+1} d2_t]'; 
% d_t = mud+d1_t+d2_t;

Az=[g1 g2 0 0;
    1 0 0 0;
    0 0 a1 a2;
    0 0 1 0];

Cz=[c1 0;
    0 0;
    0 c2;
    0 0];

% lynaponuv equation; Az*Sig*Az'+Cz*Cz'=Sig;
% vec(Sig) = (eye-kron(Az,Az))\ vec(Cz*Cz');

calA = kron(Az,Az); 
nz=size(Az,1);
%n1=size(calA,1);
n1=nz*nz;

Cz2=Cz*Cz';

vecCz2=Cz2(:);

vecSig=(eye(n1)-calA)\vecCz2;

Sig=zeros(nz,nz);
for ii=1:nz
  Sig(:,ii)=vecSig((ii-1)*nz+1:ii*nz);
end

     
% picking the elements; 

dvec = [1 0 1 0];
dvec2 = [0 1 0 1];

%variance of total endowment; 

Var_y=dvec*Sig*dvec';

Var_y2=dvec2*Sig*dvec2';
% Var_y and Var_y2 shall equal; 

% covariance of total endowment; 

Inner_z=Az*Sig;

Inner_y=dvec*Inner_z*dvec'; 

Mean_y = 0;
Corr_y= (Inner_y-Mean_y^2)/Var_y;

rho=Corr_y
vol=sqrt(Var_y)
% y_{t+1} = rho*y_t + vol*w_{t+1};
