
function [dv,fv,tv,v,dv2,fv2,tv2,v2,worstv,worstv2]=valuefnc2(beta, theta,A,B,C,R,Q)

% outputs:
% dv is the D(v), robustness-augmented covariance matrix;
% tv is the T(D(v)), fixed point
% fv is the F(D(v)), the robust decision rule;
% v is the value function, given the iteration and
% convergence, we expect that v=tv;
% worstv is the worst case shock by the evil nature;
% dv2, tv2,fv2 and v2 are corresponding ones for 2nd algorithm

% inputs:
% n is the dimension of the state vector;
% beta is the rate of time preference 
% theta is the robustness parameter, positive
% A,B,C is the corresponding matrix in x'=A x + B u + C w

% Q and R matrices are the return matrix in the form of 
% r(x,u)=-x'Rx-u'Qu for the instantaneous return function;
% note that it is orthogonalized already;

n=size(A,1);
dd=1;
dd2=1;    
%    tol=1e-15;
    tol=1e-10;
    it=1; 
    it2=1;
    maxit=15000;    
    %maxit=25000;
    maxit=35000;
    %maxit=45000;
    %maxit=100000;
    small=0.00001;
    %small=-100000000;
    small=-0.001;
    %small=0;
    %disp('the initial value of the value function');
    
    v=small*eye(n);

    small2=small;
%    small2=0.000001;
v2=small2*eye(n);
    
%    vhst=v;
%    v2hst=v2;

% row of C;
[rc,cc]=size(C);

while ((dd > tol) & (it<=maxit))
  
  % D operator
  dv=v+(beta/theta)*v*C*inv(eye(cc)-(beta/theta)*C'*v*C)*C'*v; 
  
  tv=R+beta*A'*(dv-beta*dv*B*inv(Q+beta*B'*dv*B)*B'*dv)*A;
  dd=max(max(abs(tv-v)));
  
  it=it+1;
  v=tv;
  
  if it>=maxit
    disp('WARNING: Iteration limit reached in loop');
    disp('');
  end
end

% computing the decision rule;
fv=beta*inv(Q+beta*B'*dv*B)*B'*dv*A;
worstv=(beta/theta)*inv(eye(cc) - (beta/theta)*C'*v*C) *C'*v*(A-B*fv);
    
% second approach
while ((dd2 > tol) & (it2<=maxit))
          
  % D operator
  dv2=v2+(beta/theta)*v2*C*inv(eye(cc)-(beta/theta)*C'*v2*C)*C'*v2;   
  
  % robust decision rule, hence using dv2 to evaluate;
  fv2=beta*inv(Q+beta*B'*dv2*B)*B'*dv2*A;
  
  tv2=R+fv2'*Q*fv2+beta*(A-B*fv2)'*dv2*(A-B*fv2);
  dd2=max(max(abs(tv2-v2)));
  
  it2=it2+1;
  v2=tv2;
      
  if it2>=maxit
    disp('WARNING: Iteration limit reached in loop');
    disp('');
  end
end

worstv2=(beta/theta)*inv(eye(cc) -(beta/theta)*C'*v2*C) *C'*v2*(A-B*fv2);
    
